@echo off

pushd ..

for /f %%v in ('xml sel -t -v //notes[1]/@version www\doc\index.xml') do set lastVersion=%%v

set project=aspectdng-%lastVersion%

echo Cleanup
rmdir /q /s sample-1.1\bin
rmdir /q /s sample-1.1\obj
rmdir /q /s sample-2.0\bin
rmdir /q /s sample-2.0\obj
rmdir /q /s src\aspectdng\bin
rmdir /q /s src\aspectdng\obj
rmdir /q /s src\cecil\bin
rmdir /q /s src\cecil\obj
rmdir /q /s src\unittests\bin
rmdir /q /s src\unittests\obj
rmdir /q /s src\integtest\bin
rmdir /q /s src\integtest\obj
rmdir /q /s src\integtest2\bin
rmdir /q /s src\integtest2\obj

echo Binary distribution
rmdir /s /q bin
msbuild /p:target=1.1 packaging.targets
msbuild /p:target=2.0 packaging.targets

xcopy /e /y /i sample-1.1 bin\sample-1.1
xcopy /e /y /i sample-2.0 bin\sample-2.0
xml tr -E www\doc\index.xml > www\doc\index.html
xcopy /e /y /i www\doc bin\doc

pushd bin
7za a -r -tzip ..\www\releases\%project%-bin.zip *
popd

echo Source distribution
rmdir /s /q bin
del /s /q *.backup 
del /s /q *.exe
del /s /q *.dll
del /s /q *.vshost.exe 
del /s /q *.log 
del /s /q *.user 
del /s /a a *.suo
rmdir /s /q bin obj

7za a -r -tzip -x!*.zip -x!.svn www\releases\%project%-src.zip *

copy /y www\releases\%project%-src.zip www\releases\aspectdng-latest-src.zip
copy /y www\releases\%project%-bin.zip www\releases\aspectdng-latest-bin.zip

popd
