/* 
	Author 	: Thomas GIL (DotNetGuru.org)
	Date 	: 17 september 2006
	License : Public Domain
*/
using System;
using System.Collections;
using System.Text;

using com.db4o;

namespace DB4O {
    class Person {
        private string m_Name;
        private int m_Age;

        public string Name {
            get { return m_Name; }
            set { m_Name = value; }
        }
        public int Age{
            get { return m_Age; }
            set { m_Age = value; }
        }

        public Person() { }
        public Person(string name, int age) {
            this.Name = name;
            this.Age = age;
        }

    }
    class Program {
        static void Main(string[] args) {
            Db4o.Configure().LockDatabaseFile(true);
            ObjectContainer db = Db4o.OpenFile("db.yap");
            try {
                Person p = new Person("John Doe", 31);
                db.Set(p);
                Console.WriteLine("ok, doe written");

                //~ IList persons = db.Query(delegate(Person pers) { return pers.Age > 20; });
                //~ Console.WriteLine("ok, got persons");
                //~ foreach (Person pers in persons)
                    //~ Console.WriteLine("person: " + pers.Name + ", age: " + pers.Age);
            } finally {
                db.Close();
            }
        }
    }
}
