/* 
	Author 	: Thomas GIL (DotNetGuru.org)
	Date 	: 17 september 2006
	License : Public Domain
*/
using System;
using Base;
using DotNetGuru.AspectDNG.Joinpoints;

namespace Aspects {
    public class TestAroundBody {
        const string TargetMethods = "//Type[@Name = 'TestAroundBody']//Method";

        [AroundBody(TargetMethods + "[@Name = 'TargetMethod']")]
        public static object AroundTargetMethod(JoinPoint jp) {
            int result = (int)jp.Proceed();
            return result * 2;
        }

        [AroundBody(TargetMethods + "[@Name = 'TargetMethodWithException']")]
        [AroundBody(TargetMethods + "[@Name = 'TargetStaticMethodWithException']")]
        public static object AroundTargetMethodWithException(JoinPoint jp) {
            try {
                return jp.Proceed();
            } catch (Exception) {
                //Silent
                return null;
            }
        }

        [AroundBody("* Base.B::.ctor(*)")]
        public static object AroundConstructor(MethodJoinPoint jp) {
            if (jp.NbParameters > 0) {
                jp[0] = "intercepted " + jp[0];
            }
            return jp.Proceed();
        }

        [AroundBody("* Base.B::.cctor(*)")]
        public static object AroundStaticConstructor(MethodJoinPoint jp) {
            object result = jp.Proceed();
			B.staticVal *=2;
			return result;
        }
    }
}