/* 
	Author 	: Thomas GIL (DotNetGuru.org)
	Date 	: 17 september 2006
	License : Public Domain
*/
using DotNetGuru.AspectDNG.Joinpoints;
using System;
using Base;

namespace Aspects {
    public class TestAroundField {
        [AroundFieldRead("* Base.TestAroundField::i")]
        public static object InterceptorPrimitiveRead(JoinPoint jp) {
            return 5;
        }

        [AroundFieldWrite("* Base.TestAroundField::j")]
        public static object InterceptorPrimitiveWrite(FieldSetterJoinPoint jp) {
            jp.Value = 2 * (int)jp.Value;
            return jp.Proceed();
        }

        [AroundFieldWrite("* Base.TestAroundField::staticI")]
        public static object InterceptorStaticWrite(StaticFieldSetterJoinPoint jp) {
            jp.Value = 2 * (int)jp.Value;
            return jp.Proceed();
        }
        [AroundFieldRead("* Base.TestAroundField::staticI")]
        public static object InterceptorStaticRead(StaticFieldJoinPoint jp) {
            return 3*(int)jp.Proceed();
        }
		
        [AroundFieldRead("* Base.TestAroundField::day")]
        public static object InterceptorStaticEnumRead(StaticFieldJoinPoint jp) {
			Day d = (Day) jp.Proceed();
			if (d == Day.One) return Day.Two;
			else return Day.One;
        }
	}
}