/* 
	Author 	: Thomas GIL (DotNetGuru.org)
	Date 	: 17 september 2006
	License : Public Domain
*/
using DotNetGuru.AspectDNG.Joinpoints;
using System;
using System.Text;
using Base;

using DotNetGuru.UnitTestFramework;

namespace Aspects {
    public class Brutal {
        [AroundBody("*")]
		[AroundCall("*")]
        [AroundFieldRead("*")]
        [AroundFieldWrite("*")]
        public static object Interceptor(JoinPoint jp) {
            // Console.WriteLine("intercepted : " + jp);
			object result = jp.Proceed();
            // Console.WriteLine("result : " + result);
			return result;
        }
		
		[Insert("*")]
		public object Inserted() {
			return this;
		}
		
		//~ [Generic("*")] // A bit long in a simple test. But it works fine
		public static string Manipulate(Mono.Cecil.TypeDefinition td) {
			StringBuilder sb = new StringBuilder();
			sb.Append("private int newField;");
			sb.Append("private int newMethod(){ return newField; }");
			sb.Append("private int newProperty{");
			sb.Append("	get{ return newField; }");
			sb.Append("	set{ newField = value; }");
			sb.Append("}");
			return sb.ToString();
		}
    }
}
