/* 
	Author 	: Thomas GIL (DotNetGuru.org)
	Date 	: 17 september 2006
	License : Public Domain
*/
using System;
using System.Text;
using DotNetGuru.AspectDNG.Util;
using DotNetGuru.AspectDNG.Joinpoints;
using Mono.Cecil;
using Mono.Cecil.Cil;

namespace Aspects {
    public class TestGeneric {
        [Generic("//Type[. = 'Base.TestGeneric']")]
        public static string Generator(TypeDefinition t) {
            t.Fields.Add(new FieldDefinition("Field_generated", Cil.GetTypeReference(typeof(int)), FieldAttributes.Public));
            t.Properties.Add(new PropertyDefinition("Property_generated", Cil.GetTypeReference(typeof(string)), PropertyAttributes.HasDefault));

            // Adding a public method
            StringBuilder sb = new StringBuilder();
            sb.Append("public string Method_generated(){\n");
            sb.Append("	return \"coucou\";\n");
            sb.Append("}\n");
            return sb.ToString();
        }
    }
}