/* 
	Author 	: Thomas GIL (DotNetGuru.org)
	Date 	: 17 september 2006
	License : Public Domain
*/
using System;
using System.Diagnostics;
using System.IO;
using System.Reflection;
using DotNetGuru.UnitTestFramework;

namespace Base{
	public class TestAroundBody : TestCase {

		public void Test(){
			int result = TargetMethod(5);
            AssertEqual(new StackFrame(true), 10, result);
			TargetMethodWithException();
			TargetStaticMethodWithException();
		}
		
		public void TestStaticConstructor(){
			AssertEqual(new StackFrame(true), 4, B.staticVal);
		}
		
		public void TestConstructor(){
			B b = new B();
			AssertEqual(new StackFrame(true), "intercepted Passed by the default constructor", b.val);
		}
		
		public void TestConstructorWithParameter(){
			B b = new B("param");
            AssertEqual(new StackFrame(true), "intercepted param", b.val);
		}
		
		public int TargetMethod(int data){
			return data;		
		}

		public void TargetMethodWithException(){
			throw new Exception(Constants.BusinessExceptionMessage);
		}

		public void TargetStaticMethodWithException(){
			throw new Exception(Constants.BusinessExceptionMessage);
		}
	}
	
}
