/* 
	Author 	: Thomas GIL (DotNetGuru.org)
	Date 	: 17 september 2006
	License : Public Domain
*/
using System;
using System.Diagnostics;
using System.IO;
using System.Collections;
using DotNetGuru.UnitTestFramework;

namespace Base{
	public class TestAroundCall : TestCase {
		public void TestPrimitiveTypes() {
			int result = (int) RealTarget(5, 6);
			AssertEqual(new StackFrame(true), 11, result);
		}
		
		public void TestVoid() {
			DoNothingTarget(5, 6);
		}
		
		public void TestStaticMixedTypes(){
			int result = StaticRealTargetMixed(5, 6, "hello");
            AssertEqual(new StackFrame(true), 5 + 6 + "hello".Length, result);
		}

		public void TestMixedTypes(){
			int result = RealTargetMixed(5, 6, "hello");
            AssertEqual(new StackFrame(true), 5 + 6 + "hello".Length, result);
		}
		
		public void TestConstructor(){
			A a = new A("hello");
            AssertEqual(new StackFrame(true), "value intercepted hello", a.data);
		}

		public void TestCallWrite() {
			CallWrite();
		}

		// Target methods
		public int RealTargetMixed(int data, double data2, string data3){
			return data + (int) data2;		
		}

		public object RealTarget(int data, double data2){
			return data;		
		}

		public void DoNothingTarget(int data, double data2){
		}

		public static int StaticRealTargetMixed(int data, double data2, string data3){
			return data + (int) data2;		
		}
		
		// To test AroundCall -> external methods
		public void CallWrite(){
			Console.Write("");
			for(int i=0; i<10; i++){
				Console.Write("");
				Console.Write(""); // To prevent bugs around offsets
			}
		}
	}
}
