/* 
	Author 	: Thomas GIL (DotNetGuru.org)
	Date 	: 17 september 2006
	License : Public Domain
*/
using System;
using System.Diagnostics;
using System.IO;
using System.Reflection;
using DotNetGuru.UnitTestFramework;

namespace Base{
    public class AroundCallBody : TestCase {
        class Z {
            public int i;
            public Z() {
            }
            public Z(int i)
                : this() {
                this.i = i;
            }

            public int Echo(int i) {
                return i;
            }
            public static int StaticEcho(int i) {
                return i;
            }

        }

    
        public void TestConstructor() {
            Z z = new Z(2);
            AssertEqual(new StackFrame(true), 2, z.i);
		}

        public void TestInstance() {
            Z z = new Z();
            AssertEqual(new StackFrame(true), 2, z.Echo(2));
        }

        public void TestStatic() {
            AssertEqual(new StackFrame(true), 2, Z.StaticEcho(2));
        }
	}
	
}
