/* 
	Author 	: Thomas GIL (DotNetGuru.org)
	Date 	: 17 september 2006
	License : Public Domain
*/
using System;
using System.Diagnostics;
using DotNetGuru.UnitTestFramework;

namespace Base {
	public class C{
		public string data;
		
		public C(){
			data = "initial";
		}
		public C(string val): this(){
			data += val;
		}

        public class D : C {
            public D(string val)
                : base(val + "D") {
            }

            public static D Make(string val) { return new D(val); }
        }

	}
	
	public class TestD: TestCase {
		public void TestConstructors(){
            C.D d = C.D.Make("bob");
            AssertEqual(new StackFrame(true), "initial intercepted bobD", d.data);
		}
	}
}	
