/* 
	Author 	: Thomas GIL (DotNetGuru.org)
	Date 	: 17 september 2006
	License : Public Domain
*/
using System;
using System.Diagnostics;
using System.Reflection;
using DotNetGuru.UnitTestFramework;

namespace Base{
	// Test
    public class TestDelete : TestCase {
		public void Test(){
            AssertNull(new StackFrame(true), Type.GetType("Base.ToBeDeletedClass"));
			Type t = Type.GetType("Base.ThingsToBeDeleted");
            AssertNull(new StackFrame(true), t.GetField("ToBeDeletedField", BindingFlags.NonPublic | BindingFlags.Instance));
            AssertNull(new StackFrame(true), t.GetProperty("ToBeDeletedProperty", BindingFlags.NonPublic | BindingFlags.Instance));
            AssertNull(new StackFrame(true), t.GetMethod("ToBeDeletedMethod"));
            AssertNotNull(new StackFrame(true), t.GetMethod("NotToBeDeletedMethod"));
		}
	}

	// Targets
	public class ToBeDeletedClass{}

	public class ThingsToBeDeleted{
		private int ToBeDeletedField;
		protected string ToBeDeletedProperty{ get{return null;} set{} }
		public void ToBeDeletedMethod(){}

		public void NotToBeDeletedMethod(){}
	}
}
