/* 
	Author 	: Thomas GIL (DotNetGuru.org)
	Date 	: 17 september 2006
	License : Public Domain
*/
using System;
using System.Diagnostics;
using System.Reflection;
using DotNetGuru.UnitTestFramework;

namespace Base{
	// Test
    public class Inheritance : TestCase {
		public void Test(){
			ParentClass m = new MiddleClass();
			ParentClass c = new ChildClass();
			AssertEqual(new StackFrame(true), "MiddleClass::A", m.A());
            AssertEqual(new StackFrame(true), "ChildClass::A", c.A());
            AssertEqual(new StackFrame(true), "ChildClass::B", c.B());
		}
	}

	public abstract class ParentClass{
		public virtual string A(){
			return "ParentClass::A";
		}
		public abstract string B();
	}

	public class MiddleClass : ParentClass{
		public override string A(){
			return "MiddleClass::A";
		}
		public override string B(){
			return "MiddleClass::B";
		}
	}

	public class ChildClass : MiddleClass{
		public override string A(){
			return "ChildClass::A";
		}
		public override string B(){
			return "ChildClass::B";
		}
	}

}
