/* 
	Author 	: Thomas GIL (DotNetGuru.org)
	Date 	: 17 september 2006
	License : Public Domain
*/
using System;
using System.Diagnostics;
using System.Reflection;
using DotNetGuru.UnitTestFramework;

namespace Base{
    public class TestInsert : TestCase{
		private Type type;
		
		public TestInsert(){
			type = this.GetType();
		}

		public void TestFieldInserted(){
            AssertNotNull(new StackFrame(true), type.GetField("ToBeInsertedField", Constants.Flags));
		}
		
		public void TestTypeInserted(){
            AssertNotNull(new StackFrame(true), Type.GetType("Aspects.ToBeInsertedClass"));
		}
		
		public void TestPropertyInserted(){
            AssertNotNull(new StackFrame(true), type.GetProperty("ToBeInsertedProperty", Constants.Flags));
		}
		
		public void TestMethodInserted(){
			MethodBase mb = type.GetMethod("ToBeInsertedMethod");
            AssertNotNull(new StackFrame(true), mb);
			mb.Invoke(this, null);
            AssertNull(new StackFrame(true), type.GetMethod("NotToBeInsertedMethod"));			
		}
	}
}
